<?php
@session_start();

require_once('config.php');
require_once('smarty/libs/Smarty.class.php');
require_once('lang.php');

$smarty = new Smarty();
$smarty->template_dir = '';
$smarty->compile_dir = 'templates_c/';
$smarty->config_dir = '';
$smarty->cache_dir = '';
$smarty->left_delimiter = '<{';
$smarty->right_delimiter = '}>';

unset($username);
unset($password);
if (isset($_SESSION['username'])) $username = $_SESSION['username'];

if (!isset($username) || empty($username)) {
    $username = isset($_POST['username']) ? $_POST['username'] : '';
    $password = isset($_POST['password']) ? $_POST['password'] : '';
    $errmsg = '';

    if (isset($username) && !empty($username)) {
        $errmsg = $lang['ERROR_LOGIN'];
        if (isset($password) && !empty($password)) {
            // check login
            $sid = checkAuth($username, $password);
            if ($sid !== false) {
                $buf = getServerStatus($sid);
                if ($buf === false || $buf[0] === '!') {
                    unset($_SESSION['sid']);
                    unset($_SESSION['username']);
                    $errmsg = $lang['LOGIN_AGAIN'];
                    require_once('login.php');
                    ShowLogin($username, $errmsg);
                    exit;
                }
                $_SESSION['server_data'] = explode(' ', $buf);
                // show main page
                $_SESSION['username'] = $username;
                $_SESSION['sid'] = $sid;
                require_once('menu.php');
                ShowMenu();
                exit;
            }
        }
    }
    require_once('login.php');
    ShowLogin($username, $errmsg);
    exit;
}

if (isset($_POST['logout'])) {
    sendLogout($_SESSION['sid']);
    session_unset();
    session_destroy();
    require_once('login.php');
    ShowLogin('', '');
    exit;
}

if (isset($_POST['start']))
    sendStart($_SESSION['sid'], $_POST['bandwidth'], $_POST['size']);
else if (isset($_POST['stop']))
    sendStop($_SESSION['sid']);
else if (isset($_POST['setchannel']))
    sendChannel($_SESSION['sid'], $_POST['channel_val']);
else {
    foreach ($_POST as $key => $value) {
        if (strncmp($key, 'setchannel_', 11) == 0) {
            $ch = base64_decode(substr($key, 11));
            sendChannel($_SESSION['sid'], $ch);
            break;
        }
    }
}

$buf = getServerStatus($_SESSION['sid']);
if ($buf == false || $buf[0] === '!') {
    $errmsg = $lang['LOGIN_AGAIN'];
    session_unset();
    session_destroy();
    require_once('login.php');
    ShowLogin($username, $errmsg);
    exit;
}
$_SESSION['server_data'] = explode(' ', $buf);
require_once('menu.php');
ShowMenu();
exit;

function getServerStatus($sid)
{
    global $server, $port;

    $fp = @fsockopen($server, $port);
    if (!$fp) return false;
    $buf = trim(fgets($fp));
    if ($buf[0] != '+') {
        fclose($fp);
        return $buf;
    }
    fputs($fp, "STATUS $sid\n");
    $buf = trim(fgets($fp));
    fputs($fp, "QUIT\n");
    fgets($fp);
    fclose($fp);
    return $buf;
}

function sendLogout($sid)
{
    global $server, $port;

    $fp = @fsockopen($server, $port);
    if (!$fp) return false;
    $buf = trim(fgets($fp));
    if ($buf[0] != '+') {
        fclose($fp);
        return $buf;
    }
    fputs($fp, "LOGOUT $sid\n");
    $buf = trim(fgets($fp));
    fputs($fp, "QUIT\n");
    fgets($fp);
    fclose($fp);
    return $buf;
}

function sendStart($sid, $bandwidth, $size)
{
    global $server, $port;

    $fp = @fsockopen($server, $port);
    if (!$fp) return false;
    $buf = trim(fgets($fp));
    if ($buf[0] != '+') {
        fclose($fp);
        return $buf;
    }
    fputs($fp, "START $sid $bandwidth $size\n");
    $buf = trim(fgets($fp));
    fputs($fp, "QUIT\n");
    fgets($fp);
    fclose($fp);
    return $buf;
}

function sendStop($sid)
{
    global $server, $port;

    $fp = @fsockopen($server, $port);
    if (!$fp) return false;
    $buf = trim(fgets($fp));
    if ($buf[0] != '+') {
        fclose($fp);
        return $buf;
    }
    fputs($fp, "STOP $sid\n");
    $buf = trim(fgets($fp));
    fputs($fp, "QUIT\n");
    fgets($fp);
    fclose($fp);
    return $buf;
}

function sendChannel($sid, $channel)
{
    global $server, $port;

    $fp = @fsockopen($server, $port);
    if (!$fp) return false;
    $buf = trim(fgets($fp));
    if ($buf[0] != '+') {
        fclose($fp);
        return $buf;
    }
    $ch = base64_encode($channel);
    fputs($fp, "CHANNEL $sid $ch\n");
    $buf = trim(fgets($fp));
    fputs($fp, "QUIT\n");
    fgets($fp);
    fclose($fp);
    return $buf;
}

function checkAuth($username, $password)
{
    global $server, $port;

    if ($username == '') return false;

    $fp = @fsockopen($server, $port);
    if (!$fp) return false;
    $buf = fgets($fp);
    if ($buf[0] != '+') {
        fclose($fp);
        return false;
    }
    fputs($fp, "LOGIN ".base64_encode($username)." ".base64_encode($password)."\n");
    $buf = fgets($fp);
    fputs($fp, "QUIT\n");
    fgets($fp);
    fclose($fp);
    if ($buf[0] != '+')
        return false;
    $sid = trim(substr($buf, 1));
    return $sid;
}

?>
