<?php

if (!defined('IN_MYTV')) {
    $uri = $_SERVER['REQUEST_URI'];
    $url = dirname($uri);
    header('Location: '.$url);
    exit;
}

function loadData($fname, $cur_data)
{
    $fp = fopen($fname, 'rt');
    if (!$fp) return false;
    $aData = array();
    while (!feof($fp)) {
        $buf = trim(fgets($fp));
        list($value, $name) = explode(':', $buf, 2);
        if ($cur_data == $value)
            $select = ' selected';
        else
            $select = '';
        $aData[] = array('value' => base64_encode($value),
                         'name' => htmlspecialchars($name),
                         'selected' => $select);
    }
    fclose($fp);
    return $aData;
}

function loadChannel()
{
    $fp = fopen('channel.dat', 'rt');
    if (!$fp) return false;
    $max = 0;
    while (!feof($fp)) {
        $buf = trim(fgets($fp));
        list($value, $name) = explode(':', $buf, 2);
        if ($value <= 0) continue;
        if ($value > $max) $max = $value;
        $aData[$value] = $name;
    }
    fclose($fp);
    ksort($aData);
    reset($aData);
    $i = 0;
    foreach ($aData as $value => $name) {
        if ($i == 0)
            $tr_begin = '<tr>';
        else
            $tr_begin = '';
        $i++;
        if ($i == 5) {
            $tr_end = '</tr>';
            $i = 0;
        }
        else
            $tr_end = '';
        $aChannel[] = array('value' => 'setchannel_'.base64_encode($value),
                            'name' => htmlspecialchars($value.': '.$name),
                            'tr_begin' => $tr_begin,
                            'tr_end' => $tr_end,
                            'td_begin' => '',
                            'td_end' => '');
    }
    while ($i < 5) {
        $i++;
        if ($i == 5)
            $tr_end = '</tr>';
        else
            $tr_end = '';
        $aChannel[] = array('value' => '',
                            'name' => '',
                            'tr_begin' => '',
                            'tr_end' => $tr_end,
                            'td_begin' => '<!--',
                            'td_end' => '-->');
    }
    return $aChannel;
}

function ShowMenu($msg = '')
{
    global $smarty, $lang;

    $username = $_SESSION['username'];
    $sid = $_SESSION['sid'];
    $aServerData = $_SESSION['server_data'];
    $pid = $aServerData[1];
    $bandwidth = base64_decode($aServerData[2]);
    $size = base64_decode($aServerData[3]);
    $channel = base64_decode($aServerData[4]);
    $server_file = base64_decode($aServerData[5]);
    if ($pid === '-')
        $status = $lang['SERVER_OFF'];
    else
        $status = sprintf($lang['SERVER_ON'], $pid);

    $smarty->assign(array(
            'ENCODING' => ENCODING,
            'MYTV_VER' => MYTV_VER,
            'LANG' => $lang['LANG'],
            'TITLE' => $lang['TITLE'],
            'SERVER_TITLE' => $lang['SERVER_TITLE'],
            'SERVER_STATUS' => $status,
            'CHANNEL_TITLE' => $lang['CHANNEL_TITLE'],
            'CHANNEL_VAL' => $channel,
            'MENU_SETCH' => $lang['MENU_SETCH'],
            'LOGOUT' => $lang['LOGOUT'],
            'SERVER_SCREEN_SIZE' => $lang['SERVER_SCREEN_SIZE'],
            'SERVER_BANDWIDTH' => $lang['SERVER_BANDWIDTH'],
            ));

    if ($pid !== '-') {
        $smarty->assign(array(
                'SERVER_ON_BEGIN' => '',
                'SERVER_ON_END' => '',
                'SERVER_OFF_BEGIN' => '<!--',
                'SERVER_OFF_END' => '-->',
                'VIEWTV_URL' => 'rtsp://'.$_SERVER['SERVER_NAME'].'/broadcast/'.$server_file,
                'VIEWTV_HERE' => $lang['VIEWTV_HERE'],
                'MENU_STOP' => $lang['MENU_STOP'],
                'DISABLE_BANDWIDTH' => ' disabled',
                'DISABLE_SCREEN_SIZE' => ' disabled',
                ));
    }
    else {
        $smarty->assign(array(
                'SERVER_ON_BEGIN' => '<!--',
                'SERVER_ON_END' => '-->',
                'SERVER_OFF_BEGIN' => '',
                'SERVER_OFF_END' => '',
                'MENU_START' => $lang['MENU_START'],
                'DISABLE_BANDWIDTH' => '',
                'DISABLE_SCREEN_SIZE' => '',
                ));
    }
    $aSize = loadData('screensize.dat', $size);
    $smarty->assign('size_data', $aSize);
    $aBandwidth = loadData('bandwidth.dat', $bandwidth);
    $smarty->assign('bandwidth_data', $aBandwidth);
    $aChannel = loadChannel();
    $smarty->assign('channel_data', $aChannel);

    if ($msg != '') {
        $smarty->assign(array(
                'ERROR_MESSAGE' => $msg,
                'ERROR_BEGIN' => '',
                'ERROR_END' => '',
                ));
    }
    else {
        $smarty->assign(array(
                'ERROR_MESSAGE' => '',
                'ERROR_BEGIN' => '<!--',
                'ERROR_END' => '-->',
                ));
    }
    $smarty->display('menu.tpl');
    return;
}

?>
